Bug 1405208 - AArch64 systems fail to display the grub menu when PXE booted and instead drop to a grub prompt
Summary: AArch64 systems fail to display the grub menu when PXE booted and instead dro...
Status: CLOSED ERRATA
Alias: None
Product: Fedora
Classification: Fedora
Component: grub2
Version: 26
Hardware: aarch64
OS: Linux
unspecified
unspecified
Target Milestone: ---
Assignee: Peter Jones
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Keywords:
Depends On:
Blocks: ARMTracker
TreeView+ depends on / blocked
 
Reported: 2016-12-15 21:12 UTC by Paul Whalen
Modified: 2017-06-29 23:28 UTC (History)
6 users (show)

(edit)
Clone Of:
(edit)
Last Closed: 2017-06-29 23:28:12 UTC


Attachments (Terms of Use)
fix malformed tftp packets (1.29 KB, patch)
2017-03-08 14:51 UTC, Mark Salter
no flags Details | Diff

Description Paul Whalen 2016-12-15 21:12:04 UTC
Description of problem:
AArch64 systems fail to display the grub menu when PXE booted and instead drop to a grub prompt. 

Version-Release number of selected component (if applicable):
grub2-efi-2.02-0.38.fc26.aarch64.rpm

How reproducible:
Everytime, tested on both mustang and seattle systems. 

Steps to Reproduce:
1. Use the latest from Rawhide compose - Fedora-Rawhide-20161214.n.1
2. Attempt to pxe boot the system using BOOTAA64.EFI 


Actual results:
grub prompt displayed

Expected results:
grub.cfg loaded, menu displayed.

Additional info:
Booting from USB using either BOOTAA64.EFI or grubaa64.efi works on the mustang.
Last known working with PXE - grub2-efi-2.02-0.34.fc26.

Comment 1 Fedora End Of Life 2017-02-28 10:48:04 UTC
This bug appears to have been reported against 'rawhide' during the Fedora 26 development cycle.
Changing version to '26'.

Comment 2 Mark Salter 2017-03-03 17:35:54 UTC
I'm unable to reproduce this with latest (Fedora-Rawhide-20170303.n.0). It pxe boots fine on a AMD Seattle system using firmware ROD1002C

Comment 3 Peter Robinson 2017-03-03 17:41:04 UTC
(In reply to Mark Salter from comment #2)
> I'm unable to reproduce this with latest (Fedora-Rawhide-20170303.n.0). It
> pxe boots fine on a AMD Seattle system using firmware ROD1002C

Are you using the grub that ships with the latest image in the PXE config?

Comment 4 Mark Salter 2017-03-03 19:39:30 UTC
I used grubaa64.efi from grub2-efi-2.02-0.38.fc26.aarch64.rpm. But you got me to thinking, so I grabbed the BOOTAA64.EFI and grubaa64.efi from the os/EFI directory and used those successfully also.

Comment 5 Mark Salter 2017-03-08 14:51 UTC
Created attachment 1261314 [details]
fix malformed tftp packets

After chatting with pwhalen about this, I was able to reproduce by moving the grub file to the top level tftp dir. I did a packet capture and saw corrupted tftp read requests. There appeared to be an extra byte between the filename and type fields in the read request. This turned out to be caused by a downstream patch:

0088-Normalize-slashes-in-tftp-paths.patch

This patch collapses contiguous slashes in a filename to a single slash in the tftp packet. But it still advanced the packet buffer pointer and len based on length of original name. Anyway, an easy fix. Patch atteched.

Comment 6 Fedora Update System 2017-06-26 21:27:38 UTC
grub2-2.02-0.40.fc26 has been submitted as an update to Fedora 26. https://bodhi.fedoraproject.org/updates/FEDORA-2017-01b07bc086

Comment 7 Fedora Update System 2017-06-27 20:24:50 UTC
grub2-2.02-0.40.fc26 has been pushed to the Fedora 26 testing repository. If problems still persist, please make note of it in this bug report.
See https://fedoraproject.org/wiki/QA:Updates_Testing for
instructions on how to install test updates.
You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2017-01b07bc086

Comment 8 Fedora Update System 2017-06-29 23:28:12 UTC
grub2-2.02-0.40.fc26 has been pushed to the Fedora 26 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.